# -*- coding: utf-8 -*-
"""
Created on Sun Nov 29 11:18:25 2020

@author: Lucia
"""

import pandas as pd


#------------------------------------------------------------------------------
def generate(disease_feature, diseases, features):
    
    """Function that from a list of relationships disease-feature obtains the
    feature matrix, so that rows are diseases and columns are features.
    """
    
    
    dis_feat_dict = { i : list() for i in diseases}
    
    disease_feature_array = disease_feature.to_numpy()
    
    for [disease, feature] in disease_feature_array:
        
        if not feature in dis_feat_dict[disease]:
            dis_feat_dict[disease].append(feature)
            
    bool_matr = [[0 for x in range(len(features))] for y in range(len(diseases))]
    
    count_dis = 0    
    for dis in diseases:        
        count_feat = 0        
        for feat in features:            
            if feat in dis_feat_dict[dis]:                
                bool_matr[count_dis][count_feat] = 1                
            count_feat += 1            
        count_dis += 1
    
    feature_matrix = pd.DataFrame(bool_matr)
    return feature_matrix
#------------------------------------------------------------------------------