# -*- coding: utf-8 -*-
"""
Created on Mon Nov 30 08:56:56 2020

@author: Lucia
"""

from sklearn.decomposition import PCA
from sklearn.manifold import TSNE

import matplotlib.pyplot as plt



#------------------------------------------------------------------------------
def do_pca(data, n_components):
    
    """
    """
    
    if n_components:
        pca = PCA(n_components)
        pca_result = pca.fit(data)
    
    else:
        pca = PCA()
        pca_result = pca.fit(data)
    
    return(pca_result)
#------------------------------------------------------------------------------





#------------------------------------------------------------------------------
def plot_pca_components(data):
    
    """
    """
    
    pca_result = do_pca(data, False)
    plt.plot(range(1,len(pca_result.explained_variance_ratio_)+1),
            pca_result.explained_variance_ratio_.cumsum(),
            marker = 'o',
            linestyle = '--')
    plt.title('Explained Variance by Components')
    plt.xlabel('Number of Components')
    plt.ylabel('Cumulative Explained Variance')
    plt.show()
#------------------------------------------------------------------------------





#------------------------------------------------------------------------------
def visualize_pca_2D():
    
    """
    """
    
    return
#------------------------------------------------------------------------------





#------------------------------------------------------------------------------
def do_tsne():
    
    """
    """
    
    return
#------------------------------------------------------------------------------





#------------------------------------------------------------------------------
def plot_tsne_components():
    
    """
    """
    
    return
#------------------------------------------------------------------------------





#------------------------------------------------------------------------------
def visualize_tsne_2D():
    
    """
    """
    
    return
#------------------------------------------------------------------------------